/// <reference types="react" />
import { Context } from '../editor-view/context';
import { Workspace } from '../workspace';
import { Resource } from '../resource';
export declare class EditorWindow {
    readonly resource: Resource;
    readonly workspace: Workspace;
    title: string | undefined;
    private options;
    id: string;
    icon: React.ReactElement | undefined;
    editorView: Context;
    editorViews: Map<string, Context>;
    constructor(resource: Resource, workspace: Workspace, title?: string | undefined, options?: Object);
    importSchema(schema: any): Promise<void>;
    save(): Promise<void>;
    init(): Promise<void>;
    initViewTypes: () => Promise<void>;
    execViewTypesInit: () => Promise<void>;
    setDefaultViewType: () => void;
    initViewType: (name: string) => Promise<void>;
    changeViewType: (name: string) => void;
    get project(): import("@alilc/lowcode-shell").Project;
    get innerProject(): import("@alilc/lowcode-designer").Project;
    get innerSkeleton(): import("@alilc/lowcode-editor-skeleton").Skeleton;
    get innerSetters(): import("@alilc/lowcode-editor-core").Setters;
    get innerHotkey(): import("@alilc/lowcode-editor-core").Hotkey;
    get editor(): import("@alilc/lowcode-editor-core").Editor;
    get designer(): import("@alilc/lowcode-designer").Designer;
    get innerPlugins(): import("@alilc/lowcode-designer").LowCodePluginManager;
}
