import { Designer } from '@alilc/lowcode-designer';
import { Editor } from '@alilc/lowcode-editor-core';
import { Plugins } from '@alilc/lowcode-shell';
import { IPublicApiWorkspace, IPublicResourceList, IPublicTypeResourceType } from '@alilc/lowcode-types';
import { BasicContext } from './base-context';
import { EditorWindow } from './editor-window/context';
import { Resource } from './resource';
import { ResourceType } from './resource-type';
export declare class Workspace implements IPublicApiWorkspace {
    readonly registryInnerPlugin: (designer: Designer, editor: Editor, plugins: Plugins) => Promise<void>;
    readonly shellModelFactory: any;
    context: BasicContext;
    private emitter;
    get skeleton(): import("@alilc/lowcode-editor-skeleton").Skeleton;
    get plugins(): import("@alilc/lowcode-designer").LowCodePluginManager;
    private _isActive;
    windows: EditorWindow[];
    editorWindowMap: Map<string, EditorWindow>;
    window: EditorWindow;
    private resourceTypeMap;
    private resourceList;
    constructor(registryInnerPlugin: (designer: Designer, editor: Editor, plugins: Plugins) => Promise<void>, shellModelFactory: any);
    init(): void;
    initWindow(): void;
    get isActive(): boolean;
    setActive(value: boolean): void;
    registerResourceType(resourceTypeModel: IPublicTypeResourceType): Promise<void>;
    getResourceList(): Resource[];
    setResourceList(resourceList: IPublicResourceList): void;
    onResourceListChange(fn: (resourceList: IPublicResourceList) => void): () => void;
    getResourceType(resourceName: string): ResourceType;
    get defaultResourceType(): ResourceType | null;
    removeResourceType(resourceName: string): void;
    removeEditorWindowById(id: string): void;
    private remove;
    removeEditorWindow(resourceName: string, title: string): void;
    openEditorWindowById(id: string): void;
    openEditorWindow(name: string, title: string, options: Object, viewType?: string): void;
    onChangeWindows(fn: () => void): () => void;
    emitChangeWindow(): void;
    emitChangeActiveWindow(): void;
    onChangeActiveWindow(fn: () => void): () => void;
}
