"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.EditorWindow = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _initializerDefineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerDefineProperty"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));
var _initializerWarningHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerWarningHelper"));
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _context7 = require("../editor-view/context");
var _dec, _class, _descriptor, _descriptor2;
var EditorWindow = (_dec = _lowcodeEditorCore.obx.ref, (_class = /*#__PURE__*/function () {
  function EditorWindow(resource, workspace, title, options) {
    var _this = this;
    if (title === void 0) {
      title = '';
    }
    if (options === void 0) {
      options = {};
    }
    this.resource = resource;
    this.workspace = workspace;
    this.title = title;
    this.options = options;
    this.id = (0, _lowcodeUtils.uniqueId)('window');
    this.icon = void 0;
    (0, _initializerDefineProperty2["default"])(this, "editorView", _descriptor, this);
    (0, _initializerDefineProperty2["default"])(this, "editorViews", _descriptor2, this);
    this.initViewTypes = /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var editorViews, i, name;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            editorViews = _this.resource.editorViews;
            i = 0;
          case 2:
            if (!(i < editorViews.length)) {
              _context.next = 10;
              break;
            }
            name = editorViews[i].viewName;
            _context.next = 6;
            return _this.initViewType(name);
          case 6:
            if (!_this.editorView) {
              _this.changeViewType(name);
            }
          case 7:
            i++;
            _context.next = 2;
            break;
          case 10:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    this.execViewTypesInit = /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var editorViews, i, _this$editorViews$get, name;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            editorViews = _this.resource.editorViews;
            i = 0;
          case 2:
            if (!(i < editorViews.length)) {
              _context2.next = 10;
              break;
            }
            name = editorViews[i].viewName;
            _this.changeViewType(name);
            _context2.next = 7;
            return (_this$editorViews$get = _this.editorViews.get(name)) === null || _this$editorViews$get === void 0 ? void 0 : _this$editorViews$get.init();
          case 7:
            i++;
            _context2.next = 2;
            break;
          case 10:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }));
    this.setDefaultViewType = function () {
      _this.changeViewType(_this.resource.defaultViewType);
    };
    this.initViewType = /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(name) {
        var viewInfo, editorView;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              viewInfo = _this.resource.getEditorView(name);
              if (!_this.editorViews.get(name)) {
                _context3.next = 3;
                break;
              }
              return _context3.abrupt("return");
            case 3:
              editorView = new _context7.Context(_this.workspace, _this, viewInfo, _this.options);
              _this.editorViews.set(name, editorView);
            case 5:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }));
      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }();
    this.changeViewType = function (name) {
      var _this$editorView;
      (_this$editorView = _this.editorView) === null || _this$editorView === void 0 ? void 0 : _this$editorView.setActivate(false);
      _this.editorView = _this.editorViews.get(name);
      _this.editorView.setActivate(true);
    };
    (0, _lowcodeEditorCore.makeObservable)(this);
    this.init();
    this.icon = resource.icon;
  }
  var _proto = EditorWindow.prototype;
  _proto.importSchema = /*#__PURE__*/function () {
    var _importSchema = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(schema) {
      var _this2 = this;
      var newSchema;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this.resource["import"](schema);
          case 2:
            newSchema = _context4.sent;
            if (newSchema) {
              _context4.next = 5;
              break;
            }
            return _context4.abrupt("return");
          case 5:
            Object.keys(newSchema).forEach(function (key) {
              var view = _this2.editorViews.get(key);
              view === null || view === void 0 ? void 0 : view.project.importSchema(newSchema[key]);
            });
          case 6:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this);
    }));
    function importSchema(_x2) {
      return _importSchema.apply(this, arguments);
    }
    return importSchema;
  }();
  _proto.save = /*#__PURE__*/function () {
    var _save = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
      var value, editorViews, i, _this$editorViews$get2, name, saveResult;
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            value = {};
            editorViews = this.resource.editorViews;
            i = 0;
          case 3:
            if (!(i < editorViews.length)) {
              _context5.next = 12;
              break;
            }
            name = editorViews[i].viewName;
            _context5.next = 7;
            return (_this$editorViews$get2 = this.editorViews.get(name)) === null || _this$editorViews$get2 === void 0 ? void 0 : _this$editorViews$get2.save();
          case 7:
            saveResult = _context5.sent;
            value[name] = saveResult;
          case 9:
            i++;
            _context5.next = 3;
            break;
          case 12:
            _context5.next = 14;
            return this.resource.save(value);
          case 14:
            return _context5.abrupt("return", _context5.sent);
          case 15:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this);
    }));
    function save() {
      return _save.apply(this, arguments);
    }
    return save;
  }();
  _proto.init = /*#__PURE__*/function () {
    var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.initViewTypes();
          case 2:
            _context6.next = 4;
            return this.execViewTypesInit();
          case 4:
            this.setDefaultViewType();
          case 5:
          case "end":
            return _context6.stop();
        }
      }, _callee6, this);
    }));
    function init() {
      return _init.apply(this, arguments);
    }
    return init;
  }();
  (0, _createClass2["default"])(EditorWindow, [{
    key: "project",
    get: function get() {
      var _this$editorView2;
      return (_this$editorView2 = this.editorView) === null || _this$editorView2 === void 0 ? void 0 : _this$editorView2.project;
    }
  }, {
    key: "innerProject",
    get: function get() {
      var _this$editorView3;
      return (_this$editorView3 = this.editorView) === null || _this$editorView3 === void 0 ? void 0 : _this$editorView3.innerProject;
    }
  }, {
    key: "innerSkeleton",
    get: function get() {
      var _this$editorView4;
      return (_this$editorView4 = this.editorView) === null || _this$editorView4 === void 0 ? void 0 : _this$editorView4.innerSkeleton;
    }
  }, {
    key: "innerSetters",
    get: function get() {
      var _this$editorView5;
      return (_this$editorView5 = this.editorView) === null || _this$editorView5 === void 0 ? void 0 : _this$editorView5.innerSetters;
    }
  }, {
    key: "innerHotkey",
    get: function get() {
      var _this$editorView6;
      return (_this$editorView6 = this.editorView) === null || _this$editorView6 === void 0 ? void 0 : _this$editorView6.innerHotkey;
    }
  }, {
    key: "editor",
    get: function get() {
      var _this$editorView7;
      return (_this$editorView7 = this.editorView) === null || _this$editorView7 === void 0 ? void 0 : _this$editorView7.editor;
    }
  }, {
    key: "designer",
    get: function get() {
      var _this$editorView8;
      return (_this$editorView8 = this.editorView) === null || _this$editorView8 === void 0 ? void 0 : _this$editorView8.designer;
    }
  }, {
    key: "innerPlugins",
    get: function get() {
      var _this$editorView9;
      return (_this$editorView9 = this.editorView) === null || _this$editorView9 === void 0 ? void 0 : _this$editorView9.innerPlugins;
    }
  }]);
  return EditorWindow;
}(), (_descriptor = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "editorView", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor2 = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "editorViews", [_lowcodeEditorCore.obx], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return new Map();
  }
})), _class));
exports.EditorWindow = EditorWindow;