"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.EditorWindowView = void 0;
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = require("react");
var _view = require("../editor-view/view");
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _lowcodeDesigner = require("@alilc/lowcode-designer");
var _class;
var EditorWindowView = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(EditorWindowView, _PureComponent);
  function EditorWindowView() {
    return _PureComponent.apply(this, arguments) || this;
  }
  var _proto = EditorWindowView.prototype;
  _proto.render = function render() {
    var active = this.props.active;
    var _this$props$editorWin = this.props.editorWindow,
      editorView = _this$props$editorWin.editorView,
      editorViews = _this$props$editorWin.editorViews;
    if (!editorView) {
      var Loading = _lowcodeEditorCore.engineConfig.get('loadingComponent', _lowcodeDesigner.BuiltinLoading);
      return /*#__PURE__*/React.createElement("div", {
        className: "workspace-engine-main " + (active ? 'active' : '')
      }, /*#__PURE__*/React.createElement(Loading, null));
    }
    return /*#__PURE__*/React.createElement("div", {
      className: "workspace-engine-main " + (active ? 'active' : '')
    }, Array.from(editorViews.values()).map(function (editorView) {
      return /*#__PURE__*/React.createElement(_view.EditorView, {
        key: editorView.name,
        active: editorView.active,
        editorView: editorView
      });
    }));
  };
  return EditorWindowView;
}(_react.PureComponent)) || _class;
exports.EditorWindowView = EditorWindowView;