/// <reference types="react" />
import { IPublicTypeEditorView, IPublicModelResource, IPublicResourceData, IPublicResourceTypeConfig } from '@alilc/lowcode-types';
import { ResourceType } from './resource-type';
import { Workspace as InnerWorkSpace } from './workspace';
export declare class Resource implements IPublicModelResource {
    readonly resourceData: IPublicResourceData;
    readonly resourceType: ResourceType;
    private context;
    resourceTypeInstance: IPublicResourceTypeConfig;
    editorViewMap: Map<string, IPublicTypeEditorView>;
    constructor(resourceData: IPublicResourceData, resourceType: ResourceType, workspace: InnerWorkSpace);
    get name(): string;
    get description(): string;
    get icon(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    get type(): string;
    get title(): string | undefined;
    get options(): {
        [key: string]: any;
    };
    get category(): string;
    init(): Promise<void>;
    import(schema: any): Promise<{
        [viewName: string]: any;
    }>;
    save(value: any): Promise<void>;
    get editorViews(): IPublicTypeEditorView[];
    get defaultViewType(): string;
    getEditorView(name: string): IPublicTypeEditorView;
}
