"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Resource = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _baseContext = require("./base-context");
var logger = new _lowcodeUtils.Logger({
  level: 'warn',
  bizName: 'workspace:resource'
});
var Resource = /*#__PURE__*/function () {
  function Resource(resourceData, resourceType, workspace) {
    var _this = this;
    this.resourceData = resourceData;
    this.resourceType = resourceType;
    this.context = void 0;
    this.resourceTypeInstance = void 0;
    this.editorViewMap = new Map();
    this.context = new _baseContext.BasicContext(workspace, '');
    this.resourceTypeInstance = resourceType.resourceTypeModel(this.context, {});
    this.init();
    if (this.resourceTypeInstance.editorViews) {
      this.resourceTypeInstance.editorViews.forEach(function (d) {
        _this.editorViewMap.set(d.viewName, d);
      });
    }
    if (!resourceType) {
      logger.error("resourceType[" + resourceType + "] is unValid.");
    }
  }
  var _proto = Resource.prototype;
  _proto.init = /*#__PURE__*/function () {
    var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _this$resourceTypeIns, _this$resourceTypeIns2;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (_this$resourceTypeIns = (_this$resourceTypeIns2 = this.resourceTypeInstance).init) === null || _this$resourceTypeIns === void 0 ? void 0 : _this$resourceTypeIns.call(_this$resourceTypeIns2);
          case 2:
            _context.next = 4;
            return this.context.innerPlugins.init();
          case 4:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function init() {
      return _init.apply(this, arguments);
    }
    return init;
  }();
  _proto["import"] = /*#__PURE__*/function () {
    var _import2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(schema) {
      var _this$resourceTypeIns3, _this$resourceTypeIns4;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (_this$resourceTypeIns3 = (_this$resourceTypeIns4 = this.resourceTypeInstance)["import"]) === null || _this$resourceTypeIns3 === void 0 ? void 0 : _this$resourceTypeIns3.call(_this$resourceTypeIns4, schema);
          case 2:
            return _context2.abrupt("return", _context2.sent);
          case 3:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function _import(_x) {
      return _import2.apply(this, arguments);
    }
    return _import;
  }();
  _proto.save = /*#__PURE__*/function () {
    var _save = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(value) {
      var _this$resourceTypeIns5, _this$resourceTypeIns6;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (_this$resourceTypeIns5 = (_this$resourceTypeIns6 = this.resourceTypeInstance).save) === null || _this$resourceTypeIns5 === void 0 ? void 0 : _this$resourceTypeIns5.call(_this$resourceTypeIns6, value);
          case 2:
            return _context3.abrupt("return", _context3.sent);
          case 3:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this);
    }));
    function save(_x2) {
      return _save.apply(this, arguments);
    }
    return save;
  }();
  _proto.getEditorView = function getEditorView(name) {
    return this.editorViewMap.get(name);
  };
  (0, _createClass2["default"])(Resource, [{
    key: "name",
    get: function get() {
      return this.resourceType.name;
    }
  }, {
    key: "description",
    get: function get() {
      var _this$resourceTypeIns7;
      return (_this$resourceTypeIns7 = this.resourceTypeInstance) === null || _this$resourceTypeIns7 === void 0 ? void 0 : _this$resourceTypeIns7.description;
    }
  }, {
    key: "icon",
    get: function get() {
      var _this$resourceTypeIns8;
      return (_this$resourceTypeIns8 = this.resourceTypeInstance) === null || _this$resourceTypeIns8 === void 0 ? void 0 : _this$resourceTypeIns8.icon;
    }
  }, {
    key: "type",
    get: function get() {
      return this.resourceType.type;
    }
  }, {
    key: "title",
    get: function get() {
      return this.resourceData.title || this.resourceTypeInstance.defaultTitle;
    }
  }, {
    key: "options",
    get: function get() {
      return this.resourceData.options;
    }
  }, {
    key: "category",
    get: function get() {
      var _this$resourceData;
      return (_this$resourceData = this.resourceData) === null || _this$resourceData === void 0 ? void 0 : _this$resourceData.category;
    }
  }, {
    key: "editorViews",
    get: function get() {
      return this.resourceTypeInstance.editorViews;
    }
  }, {
    key: "defaultViewType",
    get: function get() {
      return this.resourceTypeInstance.defaultViewType;
    }
  }]);
  return Resource;
}();
exports.Resource = Resource;